function y = GaussStep(y0, f, Df, h)

%calculate the methods coefficients
c = GaussNodes(1);
[A,b] = collCoeffs(c);
nNewton = 50;

% Initialise the values
y = y0;
k0 = [y;y];

% Rephrase the Gauss method as a root finding problem
F=@(k1, k2) [k1;k2]-[f(y+h*(A(1,1)*k1+A(1,2)*k2)); f(y+h*(A(2,1)*k1+A(2,2)*k2))];

DF=@(k1, k2) eye(length(k0))-h*[A(1,1)*Df(y+h*(A(1,1)*k1+A(1,2)*k2)), A(1,2)*Df(y+h*(A(1,1)*k1+A(1,2)*k2));...
        A(2,1)*Df(y+h*(A(2,1)*k1+A(2,2)*k2)), A(2,2)*Df(y+h*(A(2,1)*k1+A(2,2)*k2))];

% Solve the implicit system with "nNewton" iterations of Newton's method
k=newton(k0,F,DF,nNewton);

% Find the solution y at the new point
y = y+h*(b(1)*k(1:3)+b(2)*k(4:6));
end